/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package it.unisef.managesales.service.base;

import com.liferay.counter.service.CounterLocalService;

import com.liferay.portal.kernel.bean.BeanReference;
import com.liferay.portal.kernel.bean.IdentifiableBean;
import com.liferay.portal.kernel.dao.jdbc.SqlUpdate;
import com.liferay.portal.kernel.dao.jdbc.SqlUpdateFactoryUtil;
import com.liferay.portal.kernel.dao.orm.DynamicQuery;
import com.liferay.portal.kernel.dao.orm.DynamicQueryFactoryUtil;
import com.liferay.portal.kernel.exception.PortalException;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.search.Indexable;
import com.liferay.portal.kernel.search.IndexableType;
import com.liferay.portal.kernel.util.OrderByComparator;
import com.liferay.portal.model.PersistedModel;
import com.liferay.portal.service.BaseLocalServiceImpl;
import com.liferay.portal.service.PersistedModelLocalServiceRegistryUtil;
import com.liferay.portal.service.ResourceLocalService;
import com.liferay.portal.service.ResourceService;
import com.liferay.portal.service.UserLocalService;
import com.liferay.portal.service.UserService;
import com.liferay.portal.service.persistence.ResourcePersistence;
import com.liferay.portal.service.persistence.UserPersistence;

import it.unisef.managesales.model.Firm;
import it.unisef.managesales.service.FirmLocalService;
import it.unisef.managesales.service.FirmService;
import it.unisef.managesales.service.WorkerLocalService;
import it.unisef.managesales.service.WorkerService;
import it.unisef.managesales.service.persistence.FirmPersistence;
import it.unisef.managesales.service.persistence.WorkerPersistence;

import java.io.Serializable;

import java.util.List;

import javax.sql.DataSource;

/**
 * The base implementation of the firm local service.
 *
 * <p>
 * This implementation exists only as a container for the default service methods generated by ServiceBuilder. All custom service methods should be put in {@link it.unisef.managesales.service.impl.FirmLocalServiceImpl}.
 * </p>
 *
 * @author Giulio Piemontese
 * @see it.unisef.managesales.service.impl.FirmLocalServiceImpl
 * @see it.unisef.managesales.service.FirmLocalServiceUtil
 * @generated
 */
public abstract class FirmLocalServiceBaseImpl extends BaseLocalServiceImpl
	implements FirmLocalService, IdentifiableBean {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this class directly. Always use {@link it.unisef.managesales.service.FirmLocalServiceUtil} to access the firm local service.
	 */

	/**
	 * Adds the firm to the database. Also notifies the appropriate model listeners.
	 *
	 * @param firm the firm
	 * @return the firm that was added
	 * @throws SystemException if a system exception occurred
	 */
	@Indexable(type = IndexableType.REINDEX)
	public Firm addFirm(Firm firm) throws SystemException {
		firm.setNew(true);

		return firmPersistence.update(firm, false);
	}

	/**
	 * Creates a new firm with the primary key. Does not add the firm to the database.
	 *
	 * @param firmId the primary key for the new firm
	 * @return the new firm
	 */
	public Firm createFirm(long firmId) {
		return firmPersistence.create(firmId);
	}

	/**
	 * Deletes the firm with the primary key from the database. Also notifies the appropriate model listeners.
	 *
	 * @param firmId the primary key of the firm
	 * @return the firm that was removed
	 * @throws PortalException if a firm with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Indexable(type = IndexableType.DELETE)
	public Firm deleteFirm(long firmId) throws PortalException, SystemException {
		return firmPersistence.remove(firmId);
	}

	/**
	 * Deletes the firm from the database. Also notifies the appropriate model listeners.
	 *
	 * @param firm the firm
	 * @return the firm that was removed
	 * @throws SystemException if a system exception occurred
	 */
	@Indexable(type = IndexableType.DELETE)
	public Firm deleteFirm(Firm firm) throws SystemException {
		return firmPersistence.remove(firm);
	}

	public DynamicQuery dynamicQuery() {
		Class<?> clazz = getClass();

		return DynamicQueryFactoryUtil.forClass(Firm.class,
			clazz.getClassLoader());
	}

	/**
	 * Performs a dynamic query on the database and returns the matching rows.
	 *
	 * @param dynamicQuery the dynamic query
	 * @return the matching rows
	 * @throws SystemException if a system exception occurred
	 */
	@SuppressWarnings("rawtypes")
	public List dynamicQuery(DynamicQuery dynamicQuery)
		throws SystemException {
		return firmPersistence.findWithDynamicQuery(dynamicQuery);
	}

	/**
	 * Performs a dynamic query on the database and returns a range of the matching rows.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param dynamicQuery the dynamic query
	 * @param start the lower bound of the range of model instances
	 * @param end the upper bound of the range of model instances (not inclusive)
	 * @return the range of matching rows
	 * @throws SystemException if a system exception occurred
	 */
	@SuppressWarnings("rawtypes")
	public List dynamicQuery(DynamicQuery dynamicQuery, int start, int end)
		throws SystemException {
		return firmPersistence.findWithDynamicQuery(dynamicQuery, start, end);
	}

	/**
	 * Performs a dynamic query on the database and returns an ordered range of the matching rows.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param dynamicQuery the dynamic query
	 * @param start the lower bound of the range of model instances
	 * @param end the upper bound of the range of model instances (not inclusive)
	 * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	 * @return the ordered range of matching rows
	 * @throws SystemException if a system exception occurred
	 */
	@SuppressWarnings("rawtypes")
	public List dynamicQuery(DynamicQuery dynamicQuery, int start, int end,
		OrderByComparator orderByComparator) throws SystemException {
		return firmPersistence.findWithDynamicQuery(dynamicQuery, start, end,
			orderByComparator);
	}

	/**
	 * Returns the number of rows that match the dynamic query.
	 *
	 * @param dynamicQuery the dynamic query
	 * @return the number of rows that match the dynamic query
	 * @throws SystemException if a system exception occurred
	 */
	public long dynamicQueryCount(DynamicQuery dynamicQuery)
		throws SystemException {
		return firmPersistence.countWithDynamicQuery(dynamicQuery);
	}

	public Firm fetchFirm(long firmId) throws SystemException {
		return firmPersistence.fetchByPrimaryKey(firmId);
	}

	/**
	 * Returns the firm with the primary key.
	 *
	 * @param firmId the primary key of the firm
	 * @return the firm
	 * @throws PortalException if a firm with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public Firm getFirm(long firmId) throws PortalException, SystemException {
		return firmPersistence.findByPrimaryKey(firmId);
	}

	public PersistedModel getPersistedModel(Serializable primaryKeyObj)
		throws PortalException, SystemException {
		return firmPersistence.findByPrimaryKey(primaryKeyObj);
	}

	/**
	 * Returns a range of all the firms.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param start the lower bound of the range of firms
	 * @param end the upper bound of the range of firms (not inclusive)
	 * @return the range of firms
	 * @throws SystemException if a system exception occurred
	 */
	public List<Firm> getFirms(int start, int end) throws SystemException {
		return firmPersistence.findAll(start, end);
	}

	/**
	 * Returns the number of firms.
	 *
	 * @return the number of firms
	 * @throws SystemException if a system exception occurred
	 */
	public int getFirmsCount() throws SystemException {
		return firmPersistence.countAll();
	}

	/**
	 * Updates the firm in the database or adds it if it does not yet exist. Also notifies the appropriate model listeners.
	 *
	 * @param firm the firm
	 * @return the firm that was updated
	 * @throws SystemException if a system exception occurred
	 */
	@Indexable(type = IndexableType.REINDEX)
	public Firm updateFirm(Firm firm) throws SystemException {
		return updateFirm(firm, true);
	}

	/**
	 * Updates the firm in the database or adds it if it does not yet exist. Also notifies the appropriate model listeners.
	 *
	 * @param firm the firm
	 * @param merge whether to merge the firm with the current session. See {@link com.liferay.portal.service.persistence.BatchSession#update(com.liferay.portal.kernel.dao.orm.Session, com.liferay.portal.model.BaseModel, boolean)} for an explanation.
	 * @return the firm that was updated
	 * @throws SystemException if a system exception occurred
	 */
	@Indexable(type = IndexableType.REINDEX)
	public Firm updateFirm(Firm firm, boolean merge) throws SystemException {
		firm.setNew(false);

		return firmPersistence.update(firm, merge);
	}

	/**
	 * Returns the firm local service.
	 *
	 * @return the firm local service
	 */
	public FirmLocalService getFirmLocalService() {
		return firmLocalService;
	}

	/**
	 * Sets the firm local service.
	 *
	 * @param firmLocalService the firm local service
	 */
	public void setFirmLocalService(FirmLocalService firmLocalService) {
		this.firmLocalService = firmLocalService;
	}

	/**
	 * Returns the firm remote service.
	 *
	 * @return the firm remote service
	 */
	public FirmService getFirmService() {
		return firmService;
	}

	/**
	 * Sets the firm remote service.
	 *
	 * @param firmService the firm remote service
	 */
	public void setFirmService(FirmService firmService) {
		this.firmService = firmService;
	}

	/**
	 * Returns the firm persistence.
	 *
	 * @return the firm persistence
	 */
	public FirmPersistence getFirmPersistence() {
		return firmPersistence;
	}

	/**
	 * Sets the firm persistence.
	 *
	 * @param firmPersistence the firm persistence
	 */
	public void setFirmPersistence(FirmPersistence firmPersistence) {
		this.firmPersistence = firmPersistence;
	}

	/**
	 * Returns the worker local service.
	 *
	 * @return the worker local service
	 */
	public WorkerLocalService getWorkerLocalService() {
		return workerLocalService;
	}

	/**
	 * Sets the worker local service.
	 *
	 * @param workerLocalService the worker local service
	 */
	public void setWorkerLocalService(WorkerLocalService workerLocalService) {
		this.workerLocalService = workerLocalService;
	}

	/**
	 * Returns the worker remote service.
	 *
	 * @return the worker remote service
	 */
	public WorkerService getWorkerService() {
		return workerService;
	}

	/**
	 * Sets the worker remote service.
	 *
	 * @param workerService the worker remote service
	 */
	public void setWorkerService(WorkerService workerService) {
		this.workerService = workerService;
	}

	/**
	 * Returns the worker persistence.
	 *
	 * @return the worker persistence
	 */
	public WorkerPersistence getWorkerPersistence() {
		return workerPersistence;
	}

	/**
	 * Sets the worker persistence.
	 *
	 * @param workerPersistence the worker persistence
	 */
	public void setWorkerPersistence(WorkerPersistence workerPersistence) {
		this.workerPersistence = workerPersistence;
	}

	/**
	 * Returns the counter local service.
	 *
	 * @return the counter local service
	 */
	public CounterLocalService getCounterLocalService() {
		return counterLocalService;
	}

	/**
	 * Sets the counter local service.
	 *
	 * @param counterLocalService the counter local service
	 */
	public void setCounterLocalService(CounterLocalService counterLocalService) {
		this.counterLocalService = counterLocalService;
	}

	/**
	 * Returns the resource local service.
	 *
	 * @return the resource local service
	 */
	public ResourceLocalService getResourceLocalService() {
		return resourceLocalService;
	}

	/**
	 * Sets the resource local service.
	 *
	 * @param resourceLocalService the resource local service
	 */
	public void setResourceLocalService(
		ResourceLocalService resourceLocalService) {
		this.resourceLocalService = resourceLocalService;
	}

	/**
	 * Returns the resource remote service.
	 *
	 * @return the resource remote service
	 */
	public ResourceService getResourceService() {
		return resourceService;
	}

	/**
	 * Sets the resource remote service.
	 *
	 * @param resourceService the resource remote service
	 */
	public void setResourceService(ResourceService resourceService) {
		this.resourceService = resourceService;
	}

	/**
	 * Returns the resource persistence.
	 *
	 * @return the resource persistence
	 */
	public ResourcePersistence getResourcePersistence() {
		return resourcePersistence;
	}

	/**
	 * Sets the resource persistence.
	 *
	 * @param resourcePersistence the resource persistence
	 */
	public void setResourcePersistence(ResourcePersistence resourcePersistence) {
		this.resourcePersistence = resourcePersistence;
	}

	/**
	 * Returns the user local service.
	 *
	 * @return the user local service
	 */
	public UserLocalService getUserLocalService() {
		return userLocalService;
	}

	/**
	 * Sets the user local service.
	 *
	 * @param userLocalService the user local service
	 */
	public void setUserLocalService(UserLocalService userLocalService) {
		this.userLocalService = userLocalService;
	}

	/**
	 * Returns the user remote service.
	 *
	 * @return the user remote service
	 */
	public UserService getUserService() {
		return userService;
	}

	/**
	 * Sets the user remote service.
	 *
	 * @param userService the user remote service
	 */
	public void setUserService(UserService userService) {
		this.userService = userService;
	}

	/**
	 * Returns the user persistence.
	 *
	 * @return the user persistence
	 */
	public UserPersistence getUserPersistence() {
		return userPersistence;
	}

	/**
	 * Sets the user persistence.
	 *
	 * @param userPersistence the user persistence
	 */
	public void setUserPersistence(UserPersistence userPersistence) {
		this.userPersistence = userPersistence;
	}

	public void afterPropertiesSet() {
		PersistedModelLocalServiceRegistryUtil.register("it.unisef.managesales.model.Firm",
			firmLocalService);
	}

	public void destroy() {
		PersistedModelLocalServiceRegistryUtil.unregister(
			"it.unisef.managesales.model.Firm");
	}

	/**
	 * Returns the Spring bean ID for this bean.
	 *
	 * @return the Spring bean ID for this bean
	 */
	public String getBeanIdentifier() {
		return _beanIdentifier;
	}

	/**
	 * Sets the Spring bean ID for this bean.
	 *
	 * @param beanIdentifier the Spring bean ID for this bean
	 */
	public void setBeanIdentifier(String beanIdentifier) {
		_beanIdentifier = beanIdentifier;
	}

	public Object invokeMethod(String name, String[] parameterTypes,
		Object[] arguments) throws Throwable {
		return _clpInvoker.invokeMethod(name, parameterTypes, arguments);
	}

	protected Class<?> getModelClass() {
		return Firm.class;
	}

	protected String getModelClassName() {
		return Firm.class.getName();
	}

	/**
	 * Performs an SQL query.
	 *
	 * @param sql the sql query
	 */
	protected void runSQL(String sql) throws SystemException {
		try {
			DataSource dataSource = firmPersistence.getDataSource();

			SqlUpdate sqlUpdate = SqlUpdateFactoryUtil.getSqlUpdate(dataSource,
					sql, new int[0]);

			sqlUpdate.update();
		}
		catch (Exception e) {
			throw new SystemException(e);
		}
	}

	@BeanReference(type = FirmLocalService.class)
	protected FirmLocalService firmLocalService;
	@BeanReference(type = FirmService.class)
	protected FirmService firmService;
	@BeanReference(type = FirmPersistence.class)
	protected FirmPersistence firmPersistence;
	@BeanReference(type = WorkerLocalService.class)
	protected WorkerLocalService workerLocalService;
	@BeanReference(type = WorkerService.class)
	protected WorkerService workerService;
	@BeanReference(type = WorkerPersistence.class)
	protected WorkerPersistence workerPersistence;
	@BeanReference(type = CounterLocalService.class)
	protected CounterLocalService counterLocalService;
	@BeanReference(type = ResourceLocalService.class)
	protected ResourceLocalService resourceLocalService;
	@BeanReference(type = ResourceService.class)
	protected ResourceService resourceService;
	@BeanReference(type = ResourcePersistence.class)
	protected ResourcePersistence resourcePersistence;
	@BeanReference(type = UserLocalService.class)
	protected UserLocalService userLocalService;
	@BeanReference(type = UserService.class)
	protected UserService userService;
	@BeanReference(type = UserPersistence.class)
	protected UserPersistence userPersistence;
	private String _beanIdentifier;
	private FirmLocalServiceClpInvoker _clpInvoker = new FirmLocalServiceClpInvoker();
}